/* Copyright (c) 1992 The Geometry Center; University of Minnesota
   1300 South Second Street;  Minneapolis, MN  55454, USA;
   
This file is part of geomview/OOGL. geomview/OOGL is free software;
you can redistribute it and/or modify it only under the terms given in
the file COPYING, which you should have received along with this file.
This and other related software may be obtained via anonymous ftp from
geom.umn.edu; email: software@geom.umn.edu. */

/* Authors: Charlie Gunn, Pat Hanrahan, Stuart Levy, Tamara Munzner, Mark Phillips */

#include "transform3.h"

/*
 * Pre-multiply a matrix by translation
 *
 *       ( 1  0  0  0 )
 *       ( 0  1  0  0 )
 * [a] = ( 0  0  1  0 ) * [a] 
 *       ( tx ty tz 1 )
 */
void
Ctm3Translate( T, tx, ty, tz )
    Transform3 T;
    float tx, ty, tz;
{
    register Tm3Coord *aptr;
    register int cnt;

    aptr=T[0];
    cnt=4;
    do{
        aptr[12] += aptr[0]*tx+aptr[4]*ty+aptr[8]*tz;
        ++aptr;
    }while (--cnt);
}
