/* Copyright (c) 1992 The Geometry Center; University of Minnesota
   1300 South Second Street;  Minneapolis, MN  55454, USA;
   
This file is part of geomview/OOGL. geomview/OOGL is free software;
you can redistribute it and/or modify it only under the terms given in
the file COPYING, which you should have received along with this file.
This and other related software may be obtained via anonymous ftp from
geom.umn.edu; email: software@geom.umn.edu. */
static char *copyright = "Copyright (C) 1992 The Geometry Center";

/* Authors: Charlie Gunn, Stuart Levy, Tamara Munzner, Mark Phillips */

/*
 * Geometry Routines
 *
 * Geometry Supercomputer Project
 *
 * ROUTINE DESCRIPTION:
 * Return the geometry class structure for Lincoln
 *
 */

#include	"polylistP.h"
#include	"lincolndefs.h"

static GeomClass *aLincolnMethods = NULL;

int LincolnPresent = 1;

static char lincolnName[] = "lincoln";

char *
LincolnName()
{
	return lincolnName;
}

GeomClass *
LincolnMethods()
{
	if (!aLincolnMethods) {
		PolyListMethods(); /* Create the polylist class first, */
		aLincolnMethods = GeomSubClassCreate("polylist", lincolnName);
		aLincolnMethods->fload = (GeomFLoadFunc *) LincolnFLoad;
		aLincolnMethods->name = (GeomNameFunc *) LincolnName;
	}
	return aLincolnMethods;
}
